# abstract class Channel(T)

- Channel(T)
- Reference
- Object

## Direct Known Subclasses

- Channel::Buffered(T)
- Channel::Unbuffered(T)

## Defined in:

## Constructors

- .new(capacity) : Channel::Buffered(T)
- .new : Channel::Unbuffered(T)

## Class Method Summary

- .receive_first(channels : Tuple | Array)
- .receive_first(*channels)
- .select(ops : Tuple | Array, has_else = false)
- .select(*ops : SelectAction)
- .send_first(value, channels : Tuple | Array)
- .send_first(value, *channels)

## Instance Method Summary

- #close
- #closed?
- #inspect(io)
- #pretty_print(pp)
- #receive
- #receive?
- #receive_select_action
- #send_select_action(value : T)
- #unwait_for_receive
- #unwait_for_send
- #wait_for_receive
- #wait_for_send

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO)
inspect inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s
to_s(io : IO) to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.new(capacity) : Channel::Buffered(T) #
def self.new : Channel::Unbuffered(T) #

## Class Method Detail

def self.receive_first(channels : Tuple | Array) #
def self.receive_first(*channels) #
def self.select(ops : Tuple | Array, has_else = false) #
def self.select(*ops : SelectAction) #
def self.send_first(value, channels : Tuple | Array) #
def self.send_first(value, *channels) #

## Instance Method Detail

def close #
def closed? #
def inspect(io) #
def pretty_print(pp) #
def receive #
def receive? #
def receive_select_action #
def send_select_action(value : T) #
def unwait_for_receive #
def unwait_for_send #
def wait_for_receive #
def wait_for_send #